package {

	import net.flashpunk.*
	import net.flashpunk.utils.*
	import net.flashpunk.graphics.*

	public class Player extends GameObject {

		public static const SPEED:Number = 5;

		public var dropped:Array = [];
		public var delay:int = 0;

		public function Player(x:Number, y:Number) {
			super(x,y);
			
			//Placeholder graphic
			graphic = Image.createRect(16,16, 0xff8000);
			graphic.x = -8; graphic.y = -8;
			setHitbox(16,16,8,8);

			Input.define("up",    Key.W, Key.UP);
			Input.define("down",  Key.S, Key.DOWN);
			Input.define("left",  Key.A, Key.LEFT);
			Input.define("right", Key.D, Key.RIGHT);
		}

		public override function update(): void {
			super.update();
			
			//Input: mouse
			if(Input.mouseDown) {
				//moveTowards(world.mouseX, world.mouseY, SPEED, "solid");
			}
			//Input:Keys
			var tx:Number=x, ty:Number=y;
			if(Input.check("up"))    ty = y-100;
			if(Input.check("down"))  ty = y+100;
			if(Input.check("left"))  tx = x-100;
			if(Input.check("right")) tx = x+100;
			if(tx!=x || ty!=y) moveTowards(tx,ty,SPEED,"solid");

			// Pick up an orb
			var e:Entity = collide("orb", x, y);
			if(e) {
				var orb:Orb = e as Orb;
				if(dropped.indexOf(orb)<0) {
					trace("Pickup orb to", orb.target.name);
					world.remove(orb);
					(world as Game).addDimension(orb.target);

					world.add( new SelOrb(orb) );
					if(orb.dimension) orb.dimension.removeObject(orb);
				}
			}
			// Dropped orbs
			for each(var o:Orb in dropped) {
				if(!collideWith(o, x, y)) {
					FP.remove(dropped, o);
				}
			}

			//Stuck - pick up ...
			if(collide("solid", x, y)) delay++;
			else delay = 0;
			if(delay>30) dropped.length = 0;



		}

	}

}
